org.apache.sysds.lops

## Class BinaryM

- java.lang.Object
- - org.apache.sysds.lops.Lop
  - - org.apache.sysds.lops.BinaryM

    public class BinaryM
    extends Lop

Lop to perform binary operation. Both inputs must be matrices or vectors. Example - A = B + C, where B and C are matrices or vectors.

### Nested Class Summary

Nested Classes
`static class` `BinaryM.VectorType`

### Nested classes/interfaces inherited from class org.apache.sysds.lops.Lop

`Lop.SimpleInstType, Lop.Type, Lop.VisitStatus`

### Field Summary

### Fields inherited from class org.apache.sysds.lops.Lop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, CP_CHILD_THREAD, CP_ROOT_THREAD_ID, DATATYPE_PREFIX, FILE_SEPARATOR, FRAME_VAR_NAME_PREFIX, INSTRUCTION_DELIMITOR, LITERAL_PREFIX, MATRIX_VAR_NAME_PREFIX, NAME_VALUE_SEPARATOR, OPERAND_DELIMITOR, PROCESS_PREFIX, SAMPLE_FRACTION, SCALAR_VAR_NAME_PREFIX, UPDATE_INPLACE_PREFIX, VALUETYPE_PREFIX, VARIABLE_NAME_PLACEHOLDER`

### Constructor Summary

Constructors
Constructor and Description
`BinaryM(Lop input1, Lop input2, Types.OpOp2 op, Types.DataType dt, Types.ValueType vt, Types.ExecType et, boolean colVector)` Constructor to perform a binary operation.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`String` `getInstructions(String input1, String input2, String output)` Method should be overridden if needed
`static String` `getOpcode(Types.OpOp2 op)`
`Types.OpOp2` `getOperationType()`
`static boolean` `isOpcode(String opcode)`
`String` `toString()` Method to have Lops print their state.

### Methods inherited from class org.apache.sysds.lops.Lop

`addInput, addOutput, addToDag, createReachable, getBeginColumn, getBeginLine, getDataType, getEndColumn, getEndLine, getExecType, getFilename, getID, getInputs, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getLevel, getOutputParameters, getOutputs, getPrivacyConstraint, getProducesIntermediateOutput, getReachable, getSimpleInstructionType, getType, getValueType, getVisited, isDataExecLocation, isVariable, prepInputOperand, prepInputOperand, prepOperand, prepOperand, prepOutputOperand, prepOutputOperand, prepOutputOperand, prepScalarInputOperand, prepScalarInputOperand, prepScalarLabel, prepScalarOperand, printErrorLocation, removeConsumer, resetVisitStatus, setAllPositions, setBeginColumn, setBeginLine, setConsumerCount, setDataType, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setPrivacyConstraint, setValueType, setVisited`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### BinaryM

    public BinaryM(Lop input1,
                   Lop input2,
                   Types.OpOp2 op,
                   Types.DataType dt,
                   Types.ValueType vt,
                   Types.ExecType et,
                   boolean colVector)

Constructor to perform a binary operation.

Parameters:
  `input1` - low-level operator 1
  `input2` - low-level operator 2
  `op` - operation type
  `dt` - data type
  `vt` - value type
  `et` - exec type
  `colVector` - true if colVector

### Method Detail

#### toString

    public String toString()

Description copied from class: `Lop`
Method to have Lops print their state. This is for debugging purposes.

Specified by:
  `toString` in class `Lop`

#### getOperationType

    public Types.OpOp2 getOperationType()

#### getOpcode

    public static String getOpcode(Types.OpOp2 op)

#### isOpcode

    public static boolean isOpcode(String opcode)

#### getInstructions

    public String getInstructions(String input1,
                                  String input2,
                                  String output)

Description copied from class: `Lop`
Method should be overridden if needed

Overrides:
  `getInstructions` in class `Lop`
Parameters:
  `input1` - input 1
  `input2` - input 2
  `output` - output
Returns:
  instructions as string